<?php

namespace Traits\Validator;

use Helpers\Trad\Trad;
use Helpers\Trad\ITrad;

trait Heure
{
    abstract public function getTrad() :ITrad;

    /**
     * Véirife le format heure HH:MM
     *
     * @param string $nomChamp
     * @param string $value
     * @return bool
     */
    public function isHours(string $nomChamp, string $value = '', $obligatoire = false) : bool
    {
        if (!$value && !$obligatoire) {
            return true;
        }
        
        if (!$value && (bool)$obligatoire == true) {
            $this->validate += 1 ;
            
            $this->error .= '<br />'.Trad::strBuild($this->getTrad()->t("La date @1@ est obligatoire."), $nomChamp);
            return false;
        }
        
        if (!preg_match('/^(?:[01][0-9]|2[0-3]):[0-5][0-9]$/', $value)) {
            $this->validate += 1 ;
            $this->error .= '<br />'.Trad::strBuild($this->getTrad()->t('Le champ @1@ n\'est pas valide, il doit être sous forme HH:MM.'), $nomChamp);
            
            return false;
        }
        
        return true;
    }
    
    /**
     * Vérifie le format heure (avec seconde) HH:MM:SS
     *
     * @param string $nomChamp
     * @param string $value
     * @return bool
     */
    public function isHourWithSeconde(string $nomChamp, string $value = '', bool $obligatoire = false) : bool
    {
        if (!$value && !$obligatoire) {
            return true;
        }
        
        if (!$value && (bool)$obligatoire == true) {
            $this->validate += 1 ;
            
            $this->error .= '<br />'.Trad::strBuild($this->getTrad()->t("La date @1@ est obligatoire."), $nomChamp);
            return false;
        }
        
        if (!preg_match('/^(2[0-3]|[01][0-9]):([0-5][0-9]):([0-5][0-9])$/', $value)) {
            $this->validate += 1 ;
            $this->error .= '<br />'.Trad::strBuild($this->getTrad()->t('Le champ @1@ n\'est pas valide, il doit être sous forme HH:MM:SS.'), $nomChamp);
            
            return false;
        }
        
        return true;
    }
}
